module MvPlugin
  #
  # Plugins for moving (renaming) users.
  #

  def MvPlugin.included(c)
    # Callback, called whenever another class or module includes this
    # one. The parameter given is the name of the class or module
    # that included us.
    @includers ||= []
    @includers << c
  end

  def MvPlugin.includers
    return @includers
  end

  def runner()
    return MvRunner
  end

  def dummy_runner()
    return MvDummyRunner
  end

  def mv_domain(from, to)
    # Rename the given domain.
    raise NotImplementedError
  end

  def mv_user(from, to)
    # Rename the given user.
    raise NotImplementedError
  end

end
